###############################################################################
# SendEmail.pm                                                                #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.6.1                                                  #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2014 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
###############################################################################

$sendemailpmver = 'YaBB 2.6.1 $Revision: 0.6 $';
if ($action eq 'detailedversion') { return 1; }

require Sources::SpamCheck;

LoadLanguage('SendEmail');

SendEmailPerms();

if (!$send_email || !$allow_send_email || $iamguest || !${$uid.$username}{'en_send_email'}) { fatal_error( 'not_allowed'); }

sub SendEmail {

    $user = $INFO{'to'};
    if ( !LoadUser($user)) { fatal_error('no_profile_exists'); }

    if (${$uid.$user}{'hidemail'} && $allow_hide_email && !${$uid.$user}{'en_re_email'} && !$iamadmin) { fatal_error('not_allowed'); };

    $member_email = enc_eMail(${$uid.$user}{'email'},${$uid.$user}{'email'},q{},q{});
    if ($iamadmin) { $show_member_email = qq~($member_email)~; }

    # SpellChecker start
    if ($enable_spell_check) {
        $yyinlinestyle .= qq~<link href="$yyhtml_root/googiespell/googiespell.css" rel="stylesheet" type="text/css" />
<script type="text/javascript" src="$yyhtml_root/AJS.js"></script>
<script type="text/javascript" src="$yyhtml_root/googiespell/googiespell.js"></script>
<script type="text/javascript" src="$yyhtml_root/googiespell/cookiesupport.js"></script>~;
        my $userdefaultlang = (split /-/xsm, $abbr_lang)[0];
        $userdefaultlang ||= 'en';
        $send_email_spellcheck .= qq~GOOGIE_DEFAULT_LANG = '$userdefaultlang';
var googie1 = new GoogieSpell("$yyhtml_root/googiespell/", "$boardurl/Sources/SpellChecker.pl?lang=");
googie1.lang_chck_spell = '$spell_check{'chck_spell'}';
googie1.lang_revert = '$spell_check{'revert'}';
googie1.lang_close = '$spell_check{'close'}';
googie1.lang_rsm_edt = '$spell_check{'rsm_edt'}';
googie1.lang_no_error_found = '$spell_check{'no_error_found'}';
googie1.lang_no_suggestions = '$spell_check{'no_suggestions'}';
googie1.setSpellContainer("spell_container");
googie1.decorateTextarea("email_message");~;
        $send_email_spelldiv = qq~<div id="spell_container" style="clear: left; float: left;"></div>~;
    }
    # SpellChecker end
    get_micon();
    $yymain .= qq~
<form action="$scripturl?action=sendemail2" method="post" name="email" onsubmit="return CheckEmailFields();">
<table class="tabtitle">
    <tr>
        <th style="padding-left:1%"><img src="$micon_bg{'email'}" alt="" /> $sendemail_txt{'01'} ${$uid.$user}{'realname'}</th>
    </tr>
    </table>
    <table class="pad_3px" style="table-layout: fixed">
        <colgroup>
            <col style="width:25%" />
            <col style="width:75%" />
        </colgroup>
        <tr>
            <td class="windowbg right vtop" style="font-weight: bold;">
                <label>$sendemail_txt{'02'}:</label>
            </td>
            <td class="windowbg2">$link{$user} $show_member_email</td>
        </tr><tr>
            <td class="windowbg vtop right" style="font-weight: bold;">
                <label for="email_subject">$sendemail_txt{'03'}:</label>
            </td>
            <td class="windowbg2"><input type="text" name="email_subject" id="email_subject" size="50" maxlength="80" style="width: 400px;" /></td>
        </tr><tr>
            <td class="windowbg vtop right" style="font-weight: bold;"><label for="email_message">$sendemail_txt{'04'}:</label></td>
            <td class="windowbg2">
                <div style="float: left;">
                    <textarea cols="60" rows="15" name="email_message" id="email_message" style="width: 550px;"></textarea>
                </div>
                $send_email_spelldiv
            </td>
        </tr><tr>
            <td class="windowbg vtop right" style="font-weight: bold;"><label for="email_selfcopy">$sendemail_txt{'05'}</label></td>
            <td class="windowbg2"><input type="checkbox" name="email_selfcopy" id="email_selfcopy" />
                <br /><span class="small">$sendemail_txt{'06'}: ${$uid.$username}{'email'}</span>
            </td>
        </tr>~;
 if ( $regcheck && !$iamadmin && !$iamgmod ) {
     require Sources::Decoder;
     validation_code();
     $yymain .= qq~<tr>
            <td class="windowbg vtop right"><label for="verification">$flood_text</label></td>
            <td class="windowbg2">$showcheck</td>
        </tr><tr>
            <td class="windowbg vtop right" style="font-weight: bold;"><label for="verification">$floodtxt{'3'}:</label></td>
            <td class="windowbg2"><input type="text" maxlength="30" name="verification" id="verification" size="30" /></td>
        </tr>~;
 }
 $yymain .= qq~<tr>
            <td class="catbg center" colspan="2" style="height: 50px;">
                <input type="hidden" name="username" value="$useraccount{$user}" />
                <input type="submit" value="$sendemail_txt{'07'}" accesskey="s" class="button" />
            </td>
        </tr>
    </table>
</form>
<script type="text/javascript">
document.email.email_subject.focus();

function CheckEmailFields() {
if (document.email.email_subject.value == '') {
    alert("$sendemail_txt{'08'}");
    document.email.email_subject.focus();
    return false;
}
if (document.email.email_message.value == '') {
    alert("$sendemail_txt{'09'}");
    document.email.email_message.focus();
    return false;
}~ .
($regcheck && !$iamadmin && !$iamgmod ? qq~
if (document.email.verification.value == '') {
    alert("$sendemail_txt{'10'}");
    document.email.verification.focus();
    return false;
}~ : q{}) . qq~
return true;
}
$send_email_spellcheck
</script>~;

    $yytitle = "$sendemail_txt{'01'} ${$uid.$user}{'realname'}";
    $yynavigation = qq~&rsaquo; $sendemail_txt{'07'}~;
    template();
    return;
}

sub SendEmail2 {

    $user = $FORM{'username'};
    if (!LoadUser($user)) { fatal_error('no_profile_exists'); }

    require Sources::Mailer;
    LoadLanguage('Email');

    $recipientname = ${$uid.$user}{'realname'};
    $recipientemail = ${$uid.$user}{'email'};
    $yourname = ${$uid.$username}{'realname'};
    $youremail = ${$uid.$username}{'email'};
    $emailsubject = $FORM{'email_subject'};
    $emailmessage = $FORM{'email_message'};
    $emailselfcopy = $FORM{'email_selfcopy'};
    $yourname =~ s/\A\s+//;
    $yourname =~ s/\s+\Z//;
    $youremail =~ s/\A\s+//;
    $youremail =~ s/\s+\Z//;
    $emailmessage =~ s/\r(?=\n*)//g;

    if ( $emailsubject eq q{} ) { fatal_error('no_subject'); }
    if ( $emailmessage eq q{} ) { fatal_error('no_message'); }

    if ( $regcheck && !$iamadmin && !$iamgmod ) {
        require Sources::Decoder;
        validation_check($FORM{'verification'});
    }

    # Spam detection start
    my $spamdetected = spamcheck("$emailsubject $emailmessage");
    if (!${$uid.$FORM{$username}}{'spamcount'}) { ${$uid.$FORM{$username}}{'spamcount'} = 0; }
    if (!$iamadmin && !$iamgmod && !$iammod) {
        if ($spamdetected == 1) {
            ${$uid.$username}{'spamcount'}++;
            ${$uid.$username}{'spamtime'} = $date;
            UserAccount($username,'update');
            $spam_hits_left_count = $post_speed_count - ${$uid.$username}{'spamcount'};
            fatal_error('tsc_alert');
        }
    }
    # Spam detection end

    my $email_message = template_email($sendemail, {'recipientname' => $recipientname, 'yourname' => $yourname, 'emailsubject' => $emailsubject, 'emailmessage' => $emailmessage});
       sendmail($recipientemail, "$emailsubject", $email_message, "$yourname <$youremail>");

    if ($emailselfcopy) {
    my $copy_emailmessage = template_email($sendemail_selfcopy, {'yourname' => $yourname, 'recipientname' => $recipientname, 'emailsubject' => $emailsubject, 'emailmessage' => $emailmessage});
       sendmail($youremail, "$emailsubject", $copy_emailmessage, "$mbname <$webmaster_email>");
    }

    $yymain .= qq~
<table class="tabtitle">
    <tr>
        <th style="padding-left:1%"><img src="$micon_bg{'email'}" alt="" /> $sendemail_txt{'11'} $recipientname</th>
    </tr>
</table>
<table class="pad_3px" style="table-layout: fixed">
    <tr>
        <td class="windowbg center vtop" style="padding: 20px;">
            <span style="font-weight: bold;">$sendemail_txt{'12'} $link{$user}.</span><br /><br />
           &bull; <a href="$scripturl">$sendemail_txt{'13'}</a><br /><br />
           <span class="small">$sendemail_txt{'14'}</span>
        </td>
     </tr>
</table>~;

    $yyinlinestyle = qq~<meta http-equiv="refresh" content="5; url=$scripturl" />~;
    $yytitle = "$sendemail_txt{'11'} $recipientname";
    $yynavigation = qq~&rsaquo; $sendemail_txt{'15'}~;
    template();
    return;
}

1;